<html>
<head> 
<meta http-equiv="content-type" content="text/html; charset=koi8-r" /> 
<title>Silent Bob</title> 
<head>
<body>
<h3 align=center>SilentBob</h3>
<a href="#descr">Brief description<br></a>
<a href="#index">Code indexing<br></a>
<a href="#call_index">Calls indexing<br></a>
<a href="#tree">Direct trees of calls<br></a>
<a href="#rtree">Inversed trees of calls<br></a>
<a href="#file_search">Files searching<br></a>
<a href="#code_search">Searching in the source code<br></a>
<a href="#futex">Quick access<br></a>
<a href="#plugins">Plugins development<br></a>
<a href="#index_pp">Code indexing (Perl/Python)<br></a>
<a href="#ppf_search">Files searching (Perl/Python)<br></a>
<a href="#links">Links<br></a>
<a href="#download">Download<br></a>
<a href="#author">Author and Contacts<br></a>

<a name="descr">	<h4 align=center>Brief description</h4>
SilentBob  is an instrument for working with source code of programms. The main functionality is handling C/C++:<br>
 
<ul>
<li><a href="#index">Code indexing.</a></li>
<li><a href="#call_index">Calls indexing.<br></a></li>
<li><a href="#tree">Direct trees of calls.<br></a></li>
<li><a href="#rtree">Inversed trees of calls.<br></a></li>
<li><a href="#file_search">Files searching.<br></a></li>
<li><a href="#code_search">Searching in the source code.<br></a></li>
<li><a href="#futex">Quick access.<br></a></li>
</ul>

SilentBob supports Perl/Python via plugins:<br>
<ul>
<li><a href="#index_pp">Code indexing (Perl/Python)<br></a></li>
<li><a href="#ppf_search">Files searching (Perl/Python)<br></a></li>
</ul>

<a name="index">	<h4 align=center>Code indexing.</h4>
Code indexing is creating the index file. The sources for Silent Bob are peace of big database, which should be indexed for quick access to any part of it. In C/C++ Silent Bob indexes<br>
<ul>
<li>Functions</li>
<li>Structures</li>
<li>Classes</li>
<li>Defines (macroses)</li>
<li>Global variables</li>
</ul>
Format of index file looks like:<br>
&ltindex&gt\t&ltfile's name&gt\t&ltline number&gt\t&lt[; additional information]&gt<br>

The information of athor of the programm you're indexing and some parametrs are added to the beginning of the file. 
Index file is sorted out
by ascending for better serching, so that you may use the index file for really big sources. The index file's format is supported by some popular text editors like Vi. Furthermore the index file is used 
in many SilentBob's functions. The good idea is to create index file before working, for example:
<p>
$ sb --make-ctags<p>
"ctags" is a type of index file (other formats are not supported)

<a name="call_index"><h4 align=center>Calls indexing</h4></a>
Calls indexing is the indexing functions calls in the code. it is used to build direct and reversed calls trees. Moreover you may use it in prigramms which support "ctags". To create such type of index file you may use command: <p>
$ sb &ltFiles list&gt --call-tags <p>
<files list> may be replaced with "-L <file with files list>". It is convenient to create files list using Silent Bob. (see "<a href="#file_search">File searching</a>".).

<a name="tree">		<h4 align=center>Direct trees of calls.</h4>
You may use to see the part of index file (with indexing functions calls). All calls look like tree, where the top is the given function.<p>
$ sb &ltfunction&gt<p>
Tree of calls is the main part of programm so you scholdn't type any options. The main and only option is the indexing "depth" of tree<p>
$ sb --depth &ltN&gt &ltfunction&gt <p>

<a name="rtree">	<h4 align=center>Inversed trees of calls.</h4>
Similarly to <a href="#tree">direct</a>, but representation begins from another end.

<a name="file_search">	<h4 align=center>Files searching.</h4>
Practically it is creation list of the files, which you work with. Use this "--cfiles" option to create the list(C/C++): <p>
$ sb --cfiles <p>
Now you have file "cfiles", which includes all necessary information.
<a name="code_search">	<h4 align=center>Searching in the source code.</h4>
Use it to find any parts of C/C++ code. All comments and strings (" ") are ignored.
For searching Silent Bob uses fragments of text, parted with comma. It is important that Bob searchs not in the hole code, but in _operators_. See the command format below:<p>
$ sb -L <filelist> <pieces of code via comma><p>

<a name="futex">	<h4 align=center>Quick access.</h4>
It gives an possibility to find in the code thengs you are interasted in. The programm searchs in the index files and makes output with code fragments. It supports only C/C++. Example:<p>
$ tags <index> <index2> ... <indexN><p>
Index - name of function, structure, global variable, macros.
<a name="plugins">	<h4 align=center>Plugins development.</h4>
There is no constant plugin format. To develop your plugins you schould look through the source code. After ending of development plugin support you will be able to find API documentation here.
<a name="index_pp">	<h4 align=center>Code indexing (Perl/Python)</h4>
There are some standart plugins for Silent Bob, the functionality of one of them is indexing Perl and Python code.<br>
In Perl indexing :

<ul>
<li>Functions</li>
<li>Modules</li>
</ul>
In Python functiona and packages are indexed. For indexing use:<p>
$ sb &lt--perl | --python&gt --make-ctags <p>

<a name="ppf_search">	<h4 align=center>Files searching (Perl/Python).</h4>
To create filelist for Perl/Python sources ypu must specify language + "--files", example:<p>
$ sb <--perl | --python> --files <p>
As result ypu will get filelist: perl_files and python_files.
<a name="links">	<h4 align=center>Links</h4>
<a href="http://forum.vingrad.ru">Forum</a>, Here you may learn about lost development (my nick is GrayCardinal).
<a name="download">	<h4 align=center>Download</h4>
You may download SilentBob from sourceforge.net <a href="http://sf.net/projects/silentbob/">Here</a>,

<a name="author">	<h4 align=center>Author and Contacts</h4>
Silent Bob(c) Oleg Puchinin 2006<br>
graycardinalster at gmail dot com<br><br>

English translation: Evgeniy Ivanov<br>
green-lord at mail dot ru



</body></html>

